%define bootstrap 0
%define threads 1

Name:           sbcl
Version:        1.1.4
Release:        %mkrel 1
Summary:        Steel Bank Common Lisp compiler and runtime system
License:        Public Domain and MIT and BSD with advertising
Group:          Development/Other
URL:            http://sbcl.sourceforge.net/
Source0:        http://downloads.sourceforge.net/project/%{name}/%{name}/%{version}/%{name}-%{version}-source.tar.bz2
Source10:       customize-target-features.lisp 
Patch1:         %{name}-1.0.45-default-%{name}-home.patch
Patch2:         %{name}-0.9.5-personality.patch
Patch3:         %{name}-1.0.28-optflags.patch
Patch4:         %{name}-0.9.17-LIB_DIR.patch
Patch5:         %{name}-1.0.16-GNU_SOURCE.patch
# Allow override of contrib test failure(s)
Patch7:         %{name}-1.0.2-permissive.patch
Patch10:        %{name}-1.1.4-fdr-fix-build-with-new-glibc.patch

Requires(post): /sbin/install-info
Requires(preun):/sbin/install-info
# doc generation
BuildRequires:  ghostscript
BuildRequires:  texinfo
BuildRequires:  texlive
BuildRequires:  time
BuildRequires:  texinfo-tex
%if %{bootstrap}
BuildRequires:  clisp
%else
BuildRequires:  %{name}
%endif

%description
Steel Bank Common Lisp (SBCL) is a Open Source development environment for
Common Lisp. It includes an integrated native compiler, interpreter, and
debugger.


%prep
%setup -q
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch7 -p0
%patch10 -p2

%if %{threads}
install -m644 -p %{_sourcedir}/customize-target-features.lisp ./customize-target-features.lisp
%endif

%build
#setup SBCL_HOME, DEFAULT_SBCL_HOME and RPM_OPT_FLAGS
#these variables are available thanks to patching
export SBCL_HOME=%{_libdir}/%{name}
export DEFAULT_SBCL_HOME=%{_libdir}/%{name}
export RPM_OPT_FLAGS=$(echo %optflags | sed -e "s/-fomit-frame-pointer//")

%if %{bootstrap}
sh make.sh "clisp"
%else
sh make.sh "%{name}"
%endif

make -C doc/manual

%install
unset SBCL_HOME
export INSTALL_ROOT=%{buildroot}%{_prefix}
export LIB_DIR=%{buildroot}%{_libdir}
sh install.sh

if test %{_docdir} != %{_prefix}/share/doc ;then
   mkdir -p %{buildroot}%{_docdir}
   mv %{buildroot}%{_prefix}/share/doc/%{name} %{buildroot}%{_docdir}/
fi

## Unpackaged files
rm -f  %{buildroot}%{_infodir}/dir
# CVS crud
find %{buildroot} -name CVS -type d | xargs rm -rf
find %{buildroot} -name .cvsignore | xargs rm -f
# 'test-passed' files from %%check
find %{buildroot} -name 'test-passed' | xargs rm -vf

%post
for info in %{name}.info.* %{name}.info-1.* %{name}.info-2.* asdf.info.*
do
    %_install_info $info
done

%postun
for info in %{name}.info.* %{name}.info-1.* %{name}.info-2.* asdf.info.*
do
    %_remove_install_info $info
done

%files
%doc %{_docdir}/%{name}
%{_bindir}/*
%{_libdir}/%{name}/asdf-install/*
%{_libdir}/%{name}/asdf/*
%{_libdir}/%{name}/sb-aclrepl/*
%{_libdir}/%{name}/sb-bsd-sockets/*
%{_libdir}/%{name}/sb-cltl2/*
%{_libdir}/%{name}/sb-concurrency/*.fasl
%{_libdir}/%{name}/sb-concurrency/*.lisp
%{_libdir}/%{name}/sb-concurrency/*.texinfo
%{_libdir}/%{name}/sb-concurrency/*.asd
%{_libdir}/%{name}/sb-concurrency/tests/*
%{_libdir}/%{name}/sb-concurrency/Makefile
%{_libdir}/%{name}/sb-cover/*
%{_libdir}/%{name}/sb-executable/*
%{_libdir}/%{name}/sb-grovel/*
%{_libdir}/%{name}/sb-introspect/*
%{_libdir}/%{name}/sb-md5/*
%{_libdir}/%{name}/sb-posix/*
%{_libdir}/%{name}/sb-queue/*
%{_libdir}/%{name}/sb-rotate-byte/*
%{_libdir}/%{name}/sb-rt/*
%{_libdir}/%{name}/sb-simple-streams/*
%{_libdir}/%{name}/sb-sprof/*
%{_libdir}/%{name}/%{name}.*
%{_infodir}/*
%{_mandir}/man?/*


%changelog

* Sat Feb 02 2013 kamil <kamil> 1.1.4-1.mga3
+ Revision: 394168
- new version 1.1.4
- add P10 fdr-fix-build-with-new-glibc.patch and fix build

* Sat Dec 01 2012 kamil <kamil> 1.1.2-2.mga3
+ Revision: 324310
- rediff P3
- new version 1.1.2

* Sat Dec 01 2012 kamil <kamil> 1.0.57-2.mga3
+ Revision: 324300
- add new BR: texinfo-tex

* Mon May 28 2012 kamil <kamil> 1.0.57-1.mga3
+ Revision: 247686
- new version 1.0.57

* Fri Jan 13 2012 kamil <kamil> 1.0.55-3.mga2
+ Revision: 195490
- fix license

* Thu Jan 12 2012 kamil <kamil> 1.0.55-2.mga2
+ Revision: 195363
- disable bootstrap building

* Thu Jan 12 2012 kamil <kamil> 1.0.55-1.mga2
+ Revision: 195331
- re-include old patches and rediff them
- drop ppc and sparc patching against %%optflags in optflags.patch
- re-include customize-target-features script
- reeanble and use again old variables:
  o SBCL_HOME
  o DEFAULT_SBCL_HOME
  o RPM_OPT_FLAGS
  o LIB_DIR
- fix scriptlets to install sbcl.info-1 and sbcl.info-2 agains
- install package into old %%{_libdir}/%%{name} place

* Thu Jan 12 2012 kamil <kamil> 1.0.55-0.mga2
+ Revision: 195227
- add missing texlive to BR
- set PREFIX variable (location where the package is working) to %%{_prefix}
- rewrite installation of .info documentation
- new list of files
- drop binary files of sbcl - used previously for bootstrap
- completely rewrite .spec file, inspired by openSUSE one
- make a temporarily initial .spec
  o temporarily disable threating maintance
  o temporarily disable patches
  o make bootstrap with clisp
  o disable post,pre,postup
- new version 1.0.55
- removed %%clean section, %%defattr, cleaning in %%install

  + tv <tv>
    - fix bootstrap directory on x86_64
    - fix typo in bootstrap macro name on x86_64
    - add missing tarballs for bootstrap build
    - bootstrap build
    - imported package sbcl


* Mon Apr 11 2011 Paulo Andrade <pcpa@mandriva.com.br> 1.0.47-1mdv2011.0
+ Revision: 652674
- Update to sbcl 1.0.47

* Sat Mar 05 2011 Funda Wang <fwang@mandriva.org> 1.0.46-1
+ Revision: 642157
- New version 1.0.4on 6

* Sat Mar 05 2011 Funda Wang <fwang@mandriva.org> 1.0.45-5
+ Revision: 642116
- rebuild to obsolete old packages

* Mon Feb 07 2011 Paulo Andrade <pcpa@mandriva.com.br> 1.0.45-3
+ Revision: 636712
- Correct rpm script for istall/remove of info files

* Wed Feb 02 2011 Paulo Andrade <pcpa@mandriva.com.br> 1.0.45-2
+ Revision: 635347
- Rediff patch1 and remove logic to rename a very long named file

* Thu Jan 27 2011 Shlomi Fish <shlomif@mandriva.org> 1.0.45-1
+ Revision: 633274
- Upgrade to 1.0.45

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Update to version 1.0.40

* Mon Apr 19 2010 Frederik Himpe <fhimpe@mandriva.org> 1.0.37-1mdv2010.1
+ Revision: 536788
- update to new version 1.0.37

* Wed Mar 03 2010 Frederik Himpe <fhimpe@mandriva.org> 1.0.36-1mdv2010.1
+ Revision: 513976
- Update to new version 1.0.36

* Fri Feb 05 2010 Frederik Himpe <fhimpe@mandriva.org> 1.0.35-1mdv2010.1
+ Revision: 501257
- update to new version 1.0.35

* Fri Jan 01 2010 Frederik Himpe <fhimpe@mandriva.org> 1.0.34-1mdv2010.1
+ Revision: 484862
- update to new version 1.0.34

* Sat Nov 28 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.33-1mdv2010.1
+ Revision: 470717
- update to new version 1.0.33

* Sat Nov 07 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.32-1mdv2010.1
+ Revision: 462185
- update to new version 1.0.32

* Sat Aug 29 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.31-1mdv2010.0
+ Revision: 422325
- update to new version 1.0.31

* Wed Jul 29 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.30-1mdv2010.0
+ Revision: 404229
- Update to new version 1.0.30

* Thu Jun 04 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.29-1mdv2010.0
+ Revision: 382863
- Update to new version 1.0.29
- Updated optflags patch from Fedora

* Tue Mar 10 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.26-1mdv2009.1
+ Revision: 353466
- Update to new version 1.0.26

* Thu Feb 05 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.25-1mdv2009.1
+ Revision: 337955
- Update to new version 1.0.25
- New default-sbcl-home patch from Fedora

* Mon Jan 05 2009 Frederik Himpe <fhimpe@mandriva.org> 1.0.24-1mdv2009.1
+ Revision: 325080
- Update to new version 1.0.24

* Fri Dec 05 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.23-1mdv2009.1
+ Revision: 310915
- update to new version 1.0.23

* Fri Oct 31 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.22-1mdv2009.1
+ Revision: 299035
- update to new version 1.0.22

* Sat Oct 11 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.21-1mdv2009.1
+ Revision: 291698
- update to new version 1.0.21

* Tue Sep 02 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.20-1mdv2009.0
+ Revision: 279327
- Update to new version 1.0.20

* Tue Sep 02 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.19-3mdv2009.0
+ Revision: 279242
- Really enable multi-threading now by fixing two typos

* Sun Aug 31 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.19-2mdv2009.0
+ Revision: 277887
- Now that sbcl is bootstrapped in Mandriva, build with the sbcl rpm
  package as BuildRequires.
- Remove the binary source packages from the SRPM
- Don't compile with -fomit-frame-pointer, it's needed for debugging

* Sun Aug 31 2008 Frederik Himpe <fhimpe@mandriva.org> 1.0.19-1mdv2009.0
+ Revision: 277842
- import sbcl


